#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
#include <array>
#include <numeric>

#define endl '\n'
#define all(a) (a).begin(), (a).end()
#define len(a) (int) (a).size()
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define int long long
using namespace std;

void solve();

mt19937 rnd(2007);

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
    swap(rng, rnd);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t; cin >> t;
    int g; cin >> g;
    forn (qwe, t)
    solve();
}
vector<pair<int, int>> ans;
vector<set<int>> g1, g2;
int n;

void output(){
    cout << "Yes" << endl;
    cout << len(ans) << endl;
    for (auto i : ans) {
        cout << i.first + 1 << ' ' << i.second + 1 << endl;
    }
}

void toggle(int v, int u){
    if (g1[v].contains(u)){
        g1[v].erase(u);
        g1[u].erase(v);
    }
    else {
        g1[v].insert(u);
        g1[u].insert(v);
    }

    if (g2[v].contains(u)){
        g2[v].erase(u);
        g2[u].erase(v);
    }
    else {
        g2[v].insert(u);
        g2[u].insert(v);
    }
    ans.push_back({v, u});
}

int resolve(int v) {
    forn (i, n){
        if (v == i) continue;
        if (!g2[v].contains(i) && !g1[v].contains(i)){
            toggle(v, i);
            return i;
        }
    }
    return -1;
}

vector<vector<int>> comp;
vector<bool> used;

void dfs(int v){
    used[v] = true;
    comp.back().push_back(v);
    for (auto u : g1[v]){
        if (!used[u])
            dfs(u);
    }
}

void solve() {
    ans.clear(); g1.clear(); g2.clear();

    int m1, m2; cin >> n >> m1 >> m2;
    g1.resize(n); g2.resize(n);

    forn (i, m1){
        int v, u; cin >> v >> u;
        v--; u--;
        g1[v].insert(u);
        g1[u].insert(v);
    }

    forn (i, m2){
        int v, u; cin >> v >> u;
        v--; u--;
        g2[v].insert(u);
        g2[u].insert(v);
    }
    forn (i, n){
        if (len(g1[i]) == 0) {
            resolve(i);
        }
    }
    vector<int> isol;
    forn (i, n){
        if (len(g1[i]) == 0){
            isol.push_back(i);
        }
    }
    if (len(isol) == n) {
        if (n == 3){
            cout << "No" << endl;
            return;
        }
        forn (i, n - 1) {
            toggle(i, i + 1);
        }
        output();
        return;
    }
    else if (len(isol) >= 2){
        forn (i, len(isol) - 1){
            toggle(isol[i], isol[i + 1]);
        }
    }
    else if (len(isol) == 1){
        int v = isol[0];
        bool found = false;
        forn (i, n){
            if (i == v) continue;
            if (len(g2[i]) != 1){
                found = true;
                toggle(i, v);
                break;
            }
        }
        if (!found){
            forn (i, n){
                int u = resolve(i);
                if (u != -1) {
                    found = true;
                    toggle(v, u);
                    break;
                }
            }
        }
        if (!found && n == 3){
            cout << "No" << endl;
            return;
        }
        if (!found) {
            forn (i, n){
                forn (j, i){
                    if (i == v || j == v) continue;
                    toggle(i, j);
                    toggle(i, v);
                    found = true;
                    break;
                }
                if (found) {
                    break;
                }
            }

        }

    }
    used.assign(n, false);
    comp.clear();
    forn (v, n) {
        if (!used[v]){
            comp.push_back({});
            dfs(v);
        }
    }
    forn (i, len(comp) - 1){
        auto prv = comp[i];
        auto nxt = comp[i + 1];
        bool found = false;
        for (auto u : prv) {
            for (auto v: nxt){
                if (!g2[v].contains(u)){
                    toggle(v, u);
                    found = true;
                    goto out;
                }
            }
        }
        out:;
        if (!found) {
            toggle(*prv.begin(), *nxt.begin());
        }
    }
    output();
}
